<template>
  <div>
    <div class="d-flex justify-content-end mt-3">
      <b-button variant="success" @click="onLoadDesign">Load Design</b-button>
    </div>

    <div class="table-responsive mt-3">
      <complete-table :loading="loadingDesign" :data="data.projects">
        <template #header>
          <tr class="text-left">
            <th style="min-width: 50px" class="pl-7">
              <span class="text-dark-75">No.</span>
            </th>
            <th></th>
            <th style="min-width: 200px" class="pl-7">
              <span class="text-dark-75">Numbering</span>
            </th>
            <th style="min-width: 100px">Designer PIC</th>
            <th style="min-width: 100px">Designer Hour</th>
            <th style="min-width: 100px">Drafter PIC</th>
            <th style="min-width: 100px">Drafter Hour</th>
            <th style="min-width: 100px">Checker PIC</th>
            <th style="min-width: 100px">Checker Hour</th>
            <th style="min-width: 200px">Aksi</th>
          </tr>
        </template>

        <template #defaultBody="{ item, i }">
          <tr v-bind:key="i" :class="{ opened: opened.includes(item.numbering) }">
            <td class="pl-0 ">
                <span
                  class="ml-5 text-dark-75 font-weight-bolder d-block font-size-lg"
                >
                  {{ i + 1 }}
                </span>
              </td>
            <td><button class="btn btn-default btn-xs"  @click="toggle(item.numbering)"><span class="flaticon-eye"></span></button></td>

            <td class="pl-0 ">
              <span
                class="ml-5 text-dark-75 font-weight-bolder d-block font-size-lg"
              >
                {{ item.numbering }}
              </span>
            </td>

      

            <td>
              <template v-if="currentIndex !== i">
                <span class="text-muted font-weight-bold d-block">
                  {{ getPicName(item.designerPic.code) }}
                </span>
              </template>

              <template v-if="currentIndex === i">
                <b-form-select
                  size="lg"
                  v-model="item.designerPic.code"
                  :options="currentPicOptions"
                ></b-form-select>
              </template>
            </td>

            <td>
              <template v-if="currentIndex !== i">
                <span class="text-muted font-weight-bold d-block">
                  {{ item.designerHour }}
                </span>
              </template>

              <template v-if="currentIndex === i">
                <b-form-input
                  type="number"
                  min="0.01"
                  v-model="item.designerHour"
                  no-wheel
                ></b-form-input>
              </template>
            </td>

            <td>
              <template v-if="currentIndex !== i">
                <span class="text-muted font-weight-bold d-block">
                  {{ getPicName(item.drafterPic.code) }}
                </span>
              </template>

              <template v-if="currentIndex === i">
                <b-form-select
                  size="lg"
                  v-model="item.drafterPic.code"
                  :options="currentPicOptions"
                ></b-form-select>
              </template>
            </td>

            <td>
              <template v-if="currentIndex !== i">
                <span class="text-muted font-weight-bold d-block">
                  {{ item.drafterHour }}
                </span>
              </template>

              <template v-if="currentIndex === i">
                <b-form-input
                  type="number"
                  min="0.01"
                  v-model="item.drafterHour"
                  no-wheel
                ></b-form-input>
              </template>
            </td>

            <td>
              <template v-if="currentIndex !== i">
                <span class="text-muted font-weight-bold d-block">
                  {{ getPicName(item.checkerPic.code) }}
                </span>
              </template>

              <template v-if="currentIndex === i">
                <b-form-select
                  size="lg"
                  v-model="item.checkerPic.code"
                  :options="currentPicOptions"
                ></b-form-select>
              </template>
            </td>

            <td>
              <template v-if="currentIndex !== i">
                <span class="text-muted font-weight-bold d-block">
                  {{ item.checkerHour }}
                </span>
              </template>

              <template v-if="currentIndex === i">
                <b-form-input
                  type="number"
                  min="0.01"
                  v-model="item.checkerHour"
                  no-wheel
                ></b-form-input>
              </template>
            </td>

         

            <td class="pr-0">
              <template v-if="currentIndex !== i">
                <a
                  class="btn btn-light-success font-weight-bolder font-size-sm"
                  @click="edit(i)"
                >
                  <i class="flaticon-edit"></i>
                </a>
              </template>

              <template v-if="currentIndex === i">
                <a
                  class="btn btn-light-success font-weight-bolder font-size-sm"
                  @click="update()"
                >
                  <i class="flaticon2-check-mark"></i>
                </a>

                <a
                  class="btn btn-light-danger font-weight-bolder font-size-sm ml-3"
                  @click="cancelEdit()"
                >
                  <i class="flaticon2-cancel-music"></i>
                </a>
              </template>
            </td>
          </tr>

          <tr v-bind:key="1000 + i" v-if="opened.includes(item.numbering)">
              <td colspan="12" >
                  <template>
                    <div>
                      <div class="card p-5 gutter-b">
                        <div class="card-body p-0">
                          <div class="row">
                            <div class="col-md-3 ">
                                 <span class="text-dark-75 font-weight-bolder font-size-lg" >Title : </span><span class="text-dark-75">{{item.title}}</span>
                            </div>
                            <div class="col-md-3 ">
                                 <span class="text-dark-75 font-weight-bolder font-size-lg" >Type : </span><span class="text-dark-75">{{item.type}}</span>
                            </div>
                            <div class="col-md-3 ">
                                 <span class="text-dark-75 font-weight-bolder font-size-lg" >Stasiun : </span><span class="text-dark-75">{{item.station}}</span>
                            </div>
                            <div class="col-md-3 ">
                                 <span class="text-dark-75 font-weight-bolder font-size-lg" >Approved : </span><span class="text-dark-75">{{item.approved}}</span>
                            </div>
                          </div>
                           <div class="row">
                            <div class="col-md-3 ">
                                 <span class="text-dark-75 font-weight-bolder font-size-lg" >Category : </span><span class="text-dark-75">{{ item.category }}</span>
                            </div>
                            <div class="col-md-3 ">
                                 <span class="text-dark-75 font-weight-bolder font-size-lg" >Designer PIC : </span><span class="text-dark-75"> {{item.designerPic.code }}</span>
                            </div>
                            <div class="col-md-3 ">
                                 <span class="text-dark-75 font-weight-bolder font-size-lg" >Drafter PIC : </span><span class="text-dark-75"> {{ item.drafterPic.code }}</span>
                            </div>
                            <div class="col-md-3 ">
                                 <span class="text-dark-75 font-weight-bolder font-size-lg" >Checker PIC : </span><span class="text-dark-75">   {{item.checkerPic.code}}</span>
                            </div>
                          </div>
                          <div class="row">
                            <div class="col-md-3 ">
                                 <span class="text-dark-75 font-weight-bolder font-size-lg" >Scope : </span><span class="text-dark-75">{{ item.scope }}</span>
                            </div>
                            <div class="col-md-3 ">
                                 <span class="text-dark-75 font-weight-bolder font-size-lg" >Designer Hour : </span><span class="text-dark-75"> {{ item.designerHour }}</span>
                            </div>
                            <div class="col-md-3 ">
                                 <span class="text-dark-75 font-weight-bolder font-size-lg" >Drafter Hour : </span><span class="text-dark-75">{{ item.drafterHour }}</span>
                            </div>
                            <div class="col-md-3 ">
                                 <span class="text-dark-75 font-weight-bolder font-size-lg" >Checker Hour : </span><span class="text-dark-75">{{ item.checkerHour }}</span>
                            </div>
                          </div>
                          <div class="row">
                            <div class="col-md-3 ">
                                 <span class="text-dark-75 font-weight-bolder font-size-lg" >Status : </span><span class="text-dark-75">{{ item.status }}</span>
                            </div>
                            <div class="col-md-3 ">
                                 <span class="text-dark-75 font-weight-bolder font-size-lg" >Revision : </span><span class="text-dark-75"> {{ item.revision }}</span>
                            </div>
                            <div class="col-md-3 ">
                                 <span class="text-dark-75 font-weight-bolder font-size-lg" >Version : </span><span class="text-dark-75">{{ item.version }}</span>
                            </div>
                            <div class="col-md-3 ">
                                 <span class="text-dark-75 font-weight-bolder font-size-lg" >Date Receive : </span><span class="text-dark-75">{{ item.dateReceive  }}</span>
                            </div>
                          </div>
                          <div class="row">
                            <div class="col-md-3 ">
                                 <span class="text-dark-75 font-weight-bolder font-size-lg" >Delay : </span><span class="text-dark-75">{{ item.delay }}</span>
                            </div>
                            <div class="col-md-3 ">
                                 <span class="text-dark-75 font-weight-bolder font-size-lg" >Storage Ruang Doc: </span><span class="text-dark-75"> {{ item.storageRuangDoc }}</span>
                            </div>
                            <div class="col-md-3 ">
                                 <span class="text-dark-75 font-weight-bolder font-size-lg" >Server : </span><span class="text-dark-75">{{ item.server }}</span>
                            </div>
                            <div class="col-md-3 ">
                                 <span class="text-dark-75 font-weight-bolder font-size-lg" >Asbuilt : </span><span class="text-dark-75">{{ item.asbuilt  }}</span>
                            </div>
                          </div>
                          <div class="row">
                            <div class="col-md-3 ">
                                 <span class="text-dark-75 font-weight-bolder font-size-lg" >Return Item: </span><span class="text-dark-75"> {{ item.returnItem }}</span>
                            </div>
                            <div class="col-md-3 ">
                                 <span class="text-dark-75 font-weight-bolder font-size-lg" >Outstanding : </span><span class="text-dark-75">{{ item.outstanding.name }}</span>
                            </div>
                            
                          </div>



                        </div>
                      </div>
                    </div>
                  </template>
              </td>
          </tr>

        </template>
      </complete-table>
    </div>

    <div class="d-flex justify-content-end mt-3">
      <b-button
        variant="success"
        @click="onSave()"
        ref="kt_simpan_man_hour"
        v-if="this.data.dld.length > 0"
      >
        <i class="flaticon2-check-mark"></i> Simpan
      </b-button>
    </div>
  </div>
</template>

<script>
import { mapGetters } from "vuex";
import {
  GET_MAN_HOUR_DRW,
  CLEAN_STATE,
  POST_MAN_HOUR
} from "@/core/services/store/manhour.module.js";
import { GET_OUTSTANDING } from "@/core/services/store/outstanding.module";
import { GET_PIC } from "@/core/services/store/pic.module";
import CompleteTable from "../../../content/widgets/advance-table/CompleteTable";

export default {
  name: "Drawing",
  components: {
    CompleteTable
  },
  props: {
    project: {
      required: true
    }
  },
  data() {
    return {
      currentIndex: null,
      oldData: {},
      data: {
        dld: [],
        projects: []
      },
      pagination: {
        page: 1,
        total: 0,
        rowsPerPage: 5
      },
      search: "",
      pageOfItems: []
    };
  },
  methods: {
    edit(index) {
      this.currentIndex = index;
      //this.oldData = this.data.projects[index];
      this.oldData = this.pageOfItems[index];
    },

    remove(index) {
      //this.data.projects.splice(index, 1);
      this.pageOfItems.splice(index, 1);
    },

    cancelEdit() {
      //this.data.projects[this.currentIndex] = this.oldData;
      this.pageOfItems[this.currentIndex] = this.oldData;
      this.currentIndex = null;
    },

    update() {
      var project = this.pageOfItems[this.currentIndex];
      if (project !== null) {
        if (this.data.dld.filter(c => c.id === project.id).length > 0) {
          this.data.dld = this.data.dld.filter(c => c.id !== project.id);
        }

        this.data.dld.push({
          id: project.id,
          designer_pic: {
            code: project.designerPic.code,
            name: project.designerPic.name
          },
          designer_hour: project.designerHour,
          drafter_pic: {
            code: project.drafterPic.code,
            name: project.drafterPic.name
          },
          drafter_hour: project.drafterHour,
          checker_pic: {
            code: project.checkerPic.code,
            name: project.checkerPic.name
          },
          checker_hour: project.checkerHour,
          outstanding: {
            code: project.outstanding.code,
            name: project.outstanding.name
          }
        });
      }

      this.currentIndex = null;
    },

    loadDesign(projectID) {
      this.data.dld = [];
      this.$store
        .dispatch(GET_MAN_HOUR_DRW, {
          project_id: projectID
        })
        .then(() => this.mappingDocumentObject(this.currentManHourDrw));
    },

    cleanDocument() {
      this.$store.dispatch(CLEAN_STATE, "DRW");
      this.data.projects = [];
      this.pageOfItems = [];
    },

    onChangePage(pageOfItems) {
      // update page of items
      this.pageOfItems = pageOfItems;
    },
    getPicName(code) {
      var result = this.currentPicOptions.find(x => x.value === code);
      console.log("PIC" + result);
      if (result !== undefined) return result.text;

      return "";
    },
    getOutstandingName(code) {
      var result = this.currentOutstandingOptions.find(x => x.value === code);
      if (result !== undefined) return result.text;

      return "";
    },
    mappingDocumentObject(listDocument) {
      this.data.projects.slice(0);
      listDocument.map(doc => {
        this.data.projects.push({
          id: doc.id,
          numbering: doc.numbering,
          title: doc.title,
          type: doc.type ? doc.type.name : null,
          category: doc.category ? doc.category.name : null,
          scope: doc.scope ? doc.scope.name : null,
          station: doc.station ? doc.station.name : null,
          designerPic: {
            code: doc.designer_pic ? doc.designer_pic.code : null,
            name: doc.designer_pic ? doc.designer_pic.name : null
          },
          designerHour: doc.designer_hour,
          drafterPic: {
            code: doc.drafter_pic ? doc.drafter_pic.code : null,
            name: doc.drafter_pic ? doc.drafter_pic.name : null
          },
          drafterHour: doc.drafter_hour,
          checkerPic: {
            code: doc.checker_pic ? doc.checker_pic.code : null,
            name: doc.checker_pic ? doc.checker_pic.name : null
          },
          checkerHour: doc.checker_hour,
          approved: doc.approved,
          planingDate: doc.planning_date,
          status: doc.status,
          revision: doc.revision_version,
          version: doc.version,
          dateReceive: doc.date_receive,
          delay: doc.delay,
          storageRuangDoc: doc.storageRuangDoc,
          server: doc.server,
          asbuilt: doc.monitoring_asbuilt_status,
          returnItem: doc.return_item,
          outstanding: {
            code: doc.outstanding ? doc.outstanding.code : null,
            name: doc.outstanding ? doc.outstanding.name : null
          }
        });
      });
    },

    onLoadDesign() {
      if (this.project.code === null) {
        this.$bvToast.toast("Pilih nickname terlebih dahulu.", {
          title: "Warning",
          variant: "warning",
          solid: true
        });
      } else {
        this.loadDesign(this.project.code);
      }
    },

    onSave() {
      // set spinner to submit button
      if (this.data.dld.length > 0) {
        const submitButton = this.$refs["kt_simpan_man_hour"];
        submitButton.classList.add("spinner", "spinner-light", "spinner-right");
        setTimeout(() => {
          this.$store
            .dispatch(POST_MAN_HOUR, { dld: this.data.dld })
            .then(() => this.loadDesign(this.project.code));

          submitButton.classList.remove(
            "spinner",
            "spinner-light",
            "spinner-right"
          );
        }, 2000);
      } else {
        this.$bvToast.toast("Tidak ada data yang diperbaharui!.", {
          title: "Warning",
          variant: "warning",
          solid: true
        });
      }
    }
  },
  computed: {
    ...mapGetters([
      "getterManHourDrw",
      "loadingDesign",
      "currentPics",
      "currentOutstanding"
    ]),

    currentManHourDrw() {
      return this.getterManHourDrw;
    },

    currentIdProject() {
      return this.project.code;
    },

    currentPicOptions() {
      return this.currentPics.map(pic => {
        return {
          value: pic.code,
          text: pic.code + "-" + pic.name
        };
      });
    },

    currentOutstandingOptions() {
      return this.currentOutstanding.map(ot => {
        return {
          value: ot.code,
          text: ot.code + "-" + ot.name
        };
      });
    },

    filterItems() {
      return this.data.projects.filter(items => {
        return items.numbering.match(this.search);
      });
    }
  },
  async created() {
    await this.$store.dispatch(GET_PIC);
    await this.$store.dispatch(GET_OUTSTANDING);
  },
  watch: {
    currentIdProject(value) {
      if (value === null) {
        this.cleanDocument();
      }
    }
  }
};
</script>
